orte/mca/ras/ras.h File Reference.TH "orte/mca/ras/ras.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
orte/mca/ras/ras.h \- The Open RTE Resource Allocation Subsystem (RAS). 
.SH SYNOPSIS
.br
.PP
\fC#include 'orte_config.h'\fP
.br
\fC#include 'include/orte_constants.h'\fP
.br
\fC#include 'mca/mca.h'\fP
.br
\fC#include 'mca/ns/ns_types.h'\fP
.br
\fC#include 'ras_types.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBORTE_RAS_BASE_VERSION_1_0_0\fP"
.br
.RI "\fIMacro for use in components that are of type ras v1.0.0. \fP"
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef int(* \fBorte_ras_base_module_allocate_fn_t\fP )(\fBorte_jobid_t\fP jobid)"
.br
.RI "\fIAllocate resources to a job. \fP"
.ti -1c
.RI "typedef int(* \fBorte_ras_base_module_deallocate_fn_t\fP )(\fBorte_jobid_t\fP jobid)"
.br
.RI "\fIDeallocate resources from a job. \fP"
.ti -1c
.RI "typedef int(* \fBorte_ras_base_module_finalize_fn_t\fP )(void)"
.br
.RI "\fICleanup module resources. \fP"
.ti -1c
.RI "typedef int(* \fBorte_ras_base_module_node_insert_fn_t\fP )(\fBopal_list_t\fP *)"
.br
.RI "\fIAdd a node to the current allocation. \fP"
.ti -1c
.RI "typedef int(* \fBorte_ras_base_module_node_query_fn_t\fP )(\fBopal_list_t\fP *)"
.br
.RI "\fIQuery for a list of nodes in current allocation. \fP"
.ti -1c
.RI "typedef \fBorte_ras_base_module_1_0_0_t\fP \fBorte_ras_base_module_1_0_0_t\fP"
.br
.RI "\fIConvenience typedef. \fP"
.ti -1c
.RI "typedef \fBorte_ras_base_module_1_0_0_t\fP \fBorte_ras_base_module_t\fP"
.br
.RI "\fIConvenience typedef. \fP"
.ti -1c
.RI "typedef \fBorte_ras_base_module_t\fP *(* \fBorte_ras_base_component_init_fn_t\fP )(int *priority)"
.br
.RI "\fIComponent init / selection. \fP"
.ti -1c
.RI "typedef \fBorte_ras_base_component_1_0_0_t\fP \fBorte_ras_base_component_1_0_0_t\fP"
.br
.RI "\fIConvenience typedef. \fP"
.ti -1c
.RI "typedef \fBorte_ras_base_component_1_0_0_t\fP \fBorte_ras_base_component_t\fP"
.br
.RI "\fIConvenience typedef. \fP"
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "OMPI_DECLSPEC \fBorte_ras_base_module_t\fP \fBorte_ras\fP"
.br
.in -1c
.SH "Detailed Description"
.PP 
The Open RTE Resource Allocation Subsystem (RAS). 

The resource allocation subsystem is responsible for determining what (if any) resources have been allocated to the specified job (via some prior action), and to obtain an allocation (if possible) if resources have NOT been previously allocated. It is anticipated that ORTE users will execute an 'mpirun' or other command that invokes ORTE through one of two channels:
.PP
1. local: the user will login to the computing resource they intend to use, request a resource allocation from that system, and then execute the mpirun or other command. Thus, the allocation has already been obtained prior to ORTE's initialization. In most cases, systems pass allocation information via environmental parameters. Thus, the RAS components must know the correct environmental parameter to look for within the environment they seek to support (e.g., an LSF component should know that LSF passes allocation parameters as a specific LSF-named entity).
.PP
2. remote: the user issues an mpirun command on their notebook or desktop computer, indicating that the application is to be executed on a specific remote resource. In this case, the allocation may not have been previously requested or made. Thus, the associated RAS component must know how to request an allocation from the designated resource. To assist in this process, the RAS can turn to the information provided by the resource discovery subsystem (RDS) to learn what allocator resides on the designated resource.
.PP
The RAS operates on a per-job basis - i.e., it serves to allocate the resources for a specific job. It takes several inputs, depending upon what is provided and desired:
.PP
.IP "\(bu" 2
the jobid for which the resources are to be allocated. There are two options here: (a) the jobid can be predefined and provided to the allocator. In this case, the allocator will simply allocate resources to the job; or (b) the jobid can be set by the allocator via a request to the ORTE name services (NS) subsystem. This option is selected by calling the allocate function with the illegal jobid of ORTE_JOBID_MAX. In this case, the new jobid (set by the allocator) will be returned in the provided address (the allocate function takes a pointer to the jobid as its argument).
.PP
.PP
.IP "\(bu" 2
MCA parameters specifying preallocated resources. These resources are allocated to the specified jobid (whether set by the allocator or not) on the first request. However, subsequent requests for allocation do NOT use these parameters - the parameters are 'unset' after initial use. This is done to prevent subsequent allocation requests from unintentionally overloading the specified resources in cases where the univese is persistent and therefore servicing multiple applications.
.PP
.PP
.IP "\(bu" 2
MCA parameters specifying the name of the application(s) and the number of each application to be executed. These will usually be taken from the command line options, but could be provided via environmental parameters.
.PP
.PP
.IP "\(bu" 2
the resources defined in the ORTE_RESOURCE_SEGMENT by the RDS. When an allocation is requested for resources not previously allocated, the RAS will attempt to obtain an allocation that meets the specified requirements. For example, if the user specifies that the application must run on an Intel Itanium 2 resource under the Linux operating system, but doesn't provide the allocation or resource identification, then the allocator can (if possible) search the ORTE_RESOURCE_SEGMENT for resources meeting those specifications and attempt to obtain an allocation from them.
.PP
.PP
The RAS outputs its results into three registry segments:
.PP
(a) the ORTE_NODE_STATUS_SEGMENT. The segment consists of a registry container for each node that has been allocated to a job - for proper operation, each container MUST be described by the following set of tokens:
.PP
.IP "\(bu" 2
nodename: a unique name assigned to each node, usually obtained from the preallocated information in the environmental variables or the resource manager for the specified compute resource (e.g., LSF). For those cases where specific nodenames are not provided, the allocator can use the info provided by the RDS to attempt to determine the nodenames (e.g., if the RDS learned that the nodes are name q0-q1024 and we obtain an allocation of 100 nodes beginning at node 512, then the RAS can derive the nodenames from this information).
.PP
.PP
.IP "\(bu" 2
cellid: the id assigned to the cell within which this node exists. This id is provided in the ORTE_RESOURCE_SEGMENT.
.PP
.PP
For each node, the RAS stores the following information on the segment:
.PP
.IP "\(bu" 2
number of cpus allocated from this node to the user. This will normally be the number of cpus/node as obtained from the data provided by the RDS, but could differ in some systems.
.PP
.PP
.IP "\(bu" 2
the jobids that are utilizing this node. In systems that allow overloading of processes onto nodes, there may be multiple jobs sharing a given node.
.PP
.PP
.IP "\(bu" 2
the status of the node (up, down, rebooting, etc.). This information is provided and updated by the state-of-health (SOH) monitoring subsystem.
.PP
.PP
(b) the ORTE_JOB_SEGMENT. The RAS preallocates this segment, initializing one container for each process plus one container to store information that spans the job. This latter container houses information such as the application names, number of processes per application, process context (including argv and enviro arrays), and i/o forwarding info. The RAS does NOT establish nor fill any of the individual process info containers - rather, it preallocates the storage for those containers and places some of the job-wide information into that container. This info includes:
.PP
.IP "\(bu" 2
application names and number of processes per application
.PP
.PP
.IP "\(bu" 2
process context
.PP
.PP
The remainder of the information in that container will be supplied by other subsystems.
.PP
(c) the ORTE_RESOURCE_SEGMENT. The RAS adds information to this segment to indicate consumption of an available resource. In particular, the RAS updates fields in the respective compute resource to indicate the portion of that resource that has been allocated and therefore can be presumed consumed. This includes info on the number of nodes and cpus allocated to existing jobs - these numbers are updated by the RAS when resources are deallocated at the completion of a job.
.PP
The information provided by the RAS is consumed by the resource mapper subsystem (RMAPS) that defines which process is executed upon which node/cpu, the process launch subsystem (PLS) that actually launches each process, and others.
.PP
Because the RAS operates as a multi-component framework (i.e., multiple components may be simultaneously instantiated), the RAS functions should NOT be called directly. Instead, they should be accessed via the ORTE resource manager (RMGR) subsystem.
.SH "Define Documentation"
.PP 
.SS "#define ORTE_RAS_BASE_VERSION_1_0_0"
.PP
\fBValue:\fP
.PP
.nf
/* ras v1.0 is chained to MCA v1.0 */ \
  MCA_BASE_VERSION_1_0_0, \
  /* ras v1.0 */ \
  'ras', 1, 0, 0
.fi
Macro for use in components that are of type ras v1.0.0. 
.PP
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
